
#include	<sys/types.h>
#include	<sys/socket.h>
#include	<sys/file.h>
#include	<sys/signal.h>
#include	<netinet/in.h>
#include	<arpa/inet.h>

#include	<stdio.h>
#include	<netdb.h>
#include	<errno.h>
#include    <pthread.h>
//#include "rcmd_async.h"
extern int	errno;

//static FILE* log;
static pthread_mutex_t mut;

static void mut_init()
{
	static int once=1; if (once==1) once=0; else return;
	pthread_mutex_init(&mut,NULL);
//	fprintf(log,"MUTEX INIT\n");
//	fflush(log);
}


int					/* return socket descriptor - sockfd1 */
rcmd_async(ahost,nbhost,fd, rport, cliuname, servuname, cmd)
char	**ahost;	/* array of pointer to address of host name */
int nbhost;     /*size of array ahost*/
int *fd;        /*array of file descriptor result of rcmd*/
int	rport;		/* port on server to connect to - network byte order */
char	*cliuname;	/* username on client system (i.e., caller's username */
char	*servuname;	/* username to use on server system */
char	**cmd;		/* command string to execute on server */
{
	int			sockfd1, timo, lport;
	long			oldmask;
	char			c;
	struct sockaddr_in	serv_addr, serv2_addr;
	struct hostent		*hp;
	fd_set			readfds;
	int i;
	int fdmax;
	int nbfd_ready;
	int *fd_ready;
	int nb_to_wait=0;

	//	log=fopen("./log","w");

	mut_init();
	fd_ready = (int*)malloc(sizeof(int)*nbhost);
	//	fprintf(log,"debut du truc\n");
	//	fflush(log);
	for(i=0;i<nbhost;i++)
	{
 		fd[i]=-1;
		fd_ready[i]=0;
	}

	//	fprintf(log,"apres init\n");
	//	fflush(log);
	for(i=0;i<nbhost;i++)
	{
		sockfd1=-1;
		pthread_mutex_lock(&mut);
		//	fprintf(log,"juste avant gethostbyname %d [%s]\n",i,ahost[i]);
		//	fflush(log);
		hp = gethostbyname(ahost[i]);
				
		//	fprintf(log,"get host by name OK\n");
		//	fflush(log);
		if ( hp == NULL) {
			fd_ready[i]=1;
			fd[i]=-1;
			pthread_mutex_unlock(&mut);
			continue;
			//return(-1);
		}
	 	ahost[i] = hp->h_name;	/* return hostname we're using to caller */
 		oldmask = sigblock(sigmask(SIGURG));

		lport = IPPORT_RESERVED - 1;
		timo  = 1;
		for ( ; ; ) {
			if ( (sockfd1 = rresvport(&lport)) < 0) {
				if (errno == EAGAIN)
					fprintf(stderr, "socket: All ports in use\n");
				else
					perror("rcmd_async: socket");
				sigsetmask(oldmask);
				pthread_mutex_unlock(&mut);
				break;
			//return(-1);
			}

		 	fcntl(sockfd1, F_SETOWN, getpid());
	 		/* set pid for socket signals */

 			/*
			* Fill in the socket address of the server, and connect to
			* the server.
			*/
			bzero((char *) &serv_addr, sizeof(serv_addr));
			serv_addr.sin_family = hp->h_addrtype;
			bcopy(hp->h_addr_list[0], (caddr_t)&serv_addr.sin_addr,
			hp->h_length);

		  
			serv_addr.sin_port = rport;
			if (connect(sockfd1, (struct sockaddr *) &serv_addr,
																	sizeof(serv_addr)) >= 0)
				break;		/* OK, continue onward */

			close(sockfd1);
			if (errno == EADDRINUSE) {
				/*
				* We were able to bind the local address, but couldn't
				* connect to the server.  Decrement the starting
				* port number for rresvport() and try again.
				*/
				lport--;
				continue;
			}

		 	if (errno == ECONNREFUSED && timo <= 2) {
				/*
				* The connection was refused.  The server's system
				* is probably overloaded.  Sleep for a while, then
				* try again.  We try this 4 times (total of 15 sec).
				*/
				sleep(timo);
				timo *= 2;	/* increase timer: 1, 2, 4, 8 sec */
				continue;
			}

		 	if (hp->h_addr_list[1] != NULL) {
				/*
				* If there's another address for the host, try it.
				*/
		
				int	oerrno;

				oerrno = errno;	/* save errno over call to fprintf */
				fprintf(stderr, "connect to address %s: ",
				inet_ntoa(serv_addr.sin_addr));
				errno = oerrno;
				perror((char *) 0);

				hp->h_addr_list++;    /* incr. pointer for next time */
				bcopy(hp->h_addr_list[0], (caddr_t) &serv_addr.sin_addr,
																									hp->h_length);
				fprintf(stderr, "Trying %s...\n",
				inet_ntoa(serv_addr.sin_addr));
				continue;
			}
		 	perror(hp->h_name);	/* none of the above, quit */
	 		sigsetmask(oldmask);
 			break;
	      //return(-1);
		}

		pthread_mutex_unlock(&mut);
	    /*
	     * Caller doesn't want a secondary channel.  Write a byte
	     * of 0 to the socket, to let the server know this.
	     */
		if (sockfd1 > 0){
			write(sockfd1, "", 1);
			lport = 0;

			write(sockfd1, cliuname, strlen(cliuname)+1);
			write(sockfd1, servuname, strlen(servuname)+1);
			write(sockfd1, cmd[i], strlen(cmd[i])+1);
			fd[i]=sockfd1;
			nb_to_wait++;
		}
		else{
			fd_ready[i]=1;
		}
	}

	nbfd_ready=0;

	while(nbfd_ready<nb_to_wait)
	  {

	    FD_ZERO(&readfds);
	    fdmax=0;
	    for(i=0;i<nbhost;i++)
	      {
		if(!fd_ready[i])
		  {
		    FD_SET(fd[i], &readfds);
		    if(fd[i]>fdmax)
		      fdmax=fd[i];
		  }
	      }
	      
		
	    if((select(fdmax+1,&readfds,NULL,NULL,NULL))<=0)
	      {
//		perror("rcmd_async error");
		//exit(1);
	      }
	    for(i=0;i<nbhost;i++)
	      {

		if((fd[i]!=-1) && (FD_ISSET(fd[i],&readfds)))
		  {
		    if (read(fd[i], &c, 1) != 1) {	/* read one byte from server*/
		      perror(ahost[i]);
		      fd[i] = -1;
		      nbfd_ready++;
		      fd_ready[i]=1;
		      continue;
		      //goto bad;
		    }

		    if (c != 0) {
		      /*
		       * We didn't get back the byte of zero.  There was an error
		       * detected by the server.  Read everything else on the
		       * socket up through a newline, which is an error message from
		       * the server, and copy to stderr.*/
		

		      while (read(fd[i], &c, 1) == 1) {
			write(2, &c, 1);
			if (c == '\n')
			  break;
		      }
		      fd[i] = -1;
		      nbfd_ready++;
		      fd_ready[i]=1; 
		      continue;
		      //goto bad;
		    }
		    
		    nbfd_ready++;
		    //printf("rcmd_async: la connexion du fils %d est accepter, il y a %d connexion d'etablie(s)\n",i,nbfd_ready);
		    fd_ready[i]=1;
		}
			
	    }
	  }
//	fprintf(log,"fin du truc\n");
//	fflush(log);
	sigsetmask(oldmask);
	free (fd_ready);
	return(0);	/* all OK, return 0 all fd allocated */

}
